
//sudo arp -s 192.168.1.44 00aaaaaaaaaa

//gcc -lrt -o udp_tx_rxf udp_tx_rx.c

#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <time.h>

#define ADDRESS "192.168.2.44"
#define PORT "32002"

//---------------------------------------------------------------------------------------------------
int create_socket(void) 
	{
	int sock;
	if ((sock = socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP)) == -1)  
		{
		perror("no socket\n");
		}
	return sock;
	}

//---------------------------------------------------------------------------------------------------
struct sockaddr_in init_sockaddr(char *port, char *address) 
	{
	struct sockaddr_in sin;
	bzero(&sin, sizeof(sin));			                                          
	sin.sin_family = AF_INET;				                                        
	sin.sin_port = htons(atoi(port));		                                    
	sin.sin_addr.s_addr = inet_addr(address);                               
	return sin;
	}

int create_connection(struct sockaddr_in sin, int sock) 
	{
	if (connect(sock, (struct sockaddr *)&sin, sizeof(sin)) == -1)
		{  
		perror("no connect\n");
		close(sock);
		return -1;
		}
   return 0;
	}

//---------------------------------------------------------------------------------------------------
int main(int argc, char *argv[])
{
	pid_t newprocess;
	char tx_buf[2000], rx_buf[2000]; 
	int s, len, sin_length, nano;
	struct sockaddr_in sin;

	int data=1;
	int ende=0;

  if ((s = create_socket()) == -1) 
		{
		printf("error create_socket() \n");		
		return 1;                       
		}
   sin = init_sockaddr(PORT, ADDRESS); 

  if (create_connection(sin, s) == -1) 
		{
		printf("error create_connection\n");                        
    return 1;
		}

	newprocess = fork();
	switch(newprocess)
		{
		case -1:
			printf("error fork()");
			exit(1);
		case 0:
			// child process here...
			fflush(stdout);
			printf("child process\n");

		while(1==1)
			{
			printf("vor recfrom\n");
			len = recvfrom(s, rx_buf, sizeof(rx_buf), 0, (struct sockaddr *) &sin, &sin_length);
			if (len >= 0 )
				{
				printf("recvfrom %d\n",len);
				}  
			}
			break;
		
		default:
			// parent process here...
			printf("parent process\n");
			while (ende==0)
				{
				sleep(1);
				sprintf(tx_buf,"%.4x dies ist ein langer test",data);
				len = strlen(tx_buf);
				printf("tx %d\n",data);
				if ((len = sendto(s, tx_buf, len, 0, (struct sockaddr *) &sin, sizeof(sin))) < 0)
					{
					printf("error sendto");
					ende=1;
					} 
				if (data<200) data++; else data=1;
				}
			break;
		}
	exit(0);			
	}


